# Ch 6. Pragramming practice
import numpy as np

class VECTOR3D:
    def __init__(self,x,y,z):
        self.x = x
        self.y = y
        self.z = z 

    def magnitude(self):
        # |(x,y,z)|=sqrt(x*x+y*y+z*z)
        return np.sqrt(self.x*self.x+self.y*self.y+self.z*self.z)
        
    def inner_product(self,v1):
        # self dot v1 = self.x*v1.x+self.y*v1.y+self.z*v1.z*self
        return self.x*v1.x+self.y*v1.y+self.z*v1.z
        
    def cross_product(self,v1):
        # self X v1 = VECTOR3D(self.y*v1.z-self.z*v1.y,self.z*v1.x-self.x*v1.z,self.x*v1.y-self.y*v1.x)
        return VECTOR3D(self.y*v1.z-self.z*v1.y,self.z*v1.x-self.x*v1.z,self.x*v1.y-self.y*v1.x)
        
# Test 
v1 = VECTOR3D(1,2,3)   # v1=(1,2,3)
v2 = VECTOR3D(2,5,-7)  # v2=(2,5,-7)
print("|v1|=", v1.magnitude())
print("|v2|=", v2.magnitude())
print("v1 dot v2=", v1.inner_product(v2))
v1Xv2 = v1.cross_product(v2)
print("v1Xv2 =(",v1Xv2.x,",",v1Xv2.y,",",v1Xv2.z,")")
